// Copyright (c) Graham Relf, UK, 2021
// www.grelf.net
'use strict';

function Daisy (centreX, centreY, halfheight)
{ Shape.call (this);
  this.centre = new Point3D (centreX, centreY, halfheight);
  this.radius = 1;
  this.halfheight = halfheight;
  var ht = halfheight * 2;
  this.stem = createHexagon (centreX, centreY, 0.1).extrude (ht);
  this.stem.setColour (128, 255, 128);
  this.stem.setStroking (false);
  var nPetals = (Math.random () > 0.5) ? 7 : 8;
  this.middle = createRegularPolygon (centreX, centreY, nPetals, 0.3);
  this.middle.setColour (200, 200, 0);
  this.middle.translate (0, 0, ht);
  this.petals = [];
  this.loves = true;
  var da = 360 / nPetals;
  var c0 = new Point3D (centreX, centreY, 0), r7 = this.radius * 0.7;
  for (var i = 0, a = 0; i < nPetals; i++, a += da)
  { var petal = new Polygon (centreX, centreY,
      [c0, c0.newOffsetPt (-0.25, r7, 0),
       c0.newOffsetPt (0, this.radius, 0), c0.newOffsetPt (0.25, r7, 0)]);
    if (a > 0) petal.rotateZ (a);
    petal.translate (0, 0, ht);
    petal.setColour (255, 255, 255);
    petal.setStroking (false);
    this.petals.push (petal);
    petal.isTarget = true;
    petal.daisy = this;
    petal.response = function ()
    { var hs = "He loves me";
      if (!this.daisy.loves) hs += " not";
      this.daisy.loves = !this.daisy.loves;
      hint (hs);
      for (var i = 0; i < this.daisy.petals.length; i++)
      { if (this.daisy.petals [i] === this)
        { this.daisy.petals.splice (i, 1);
      } }
      this.setStroke (128, 128, 128);
      this.isFragment = true;
      this.movable = true;
      this.setFreeFall (true);
      world.shapes.push (this); // for cleaner!
    };
    world.targets.push (petal);
  }
}

Daisy.prototype = Object.create (Shape.prototype);
Daisy.prototype.constructor = Daisy;

Daisy.prototype.view = function (me, fogNo)
{ this.stem.view (me, fogNo);
  for (var i = 0; i < this.petals.length; i++) this.petals [i].view (me, fogNo);
  this.middle.view (me, fogNo);
};
