// Copyright (c) Graham Relf, UK, 2021
// www.grelf.net
'use strict';

// Created east-west
function Ladder (midBasePt, width, height, nRungs, rgb)
{ Shape.call (this);
  var wd2 = width / 2, ht2 = height / 2;
  var thick = width * 0.03, spacing = height / nRungs;
  this.centre = new Point3D (midBasePt.x, midBasePt.y, midBasePt.z + ht2);
  var left = new Cuboid (this.centre.x - wd2, this.centre.y, this.centre.z, thick, thick, ht2);
  var right = new Cuboid (this.centre.x + wd2, this.centre.y, this.centre.z, thick, thick, ht2);
  var rungs = [], rungHt0 = midBasePt.z + spacing * 0.5;
  for (var i = 0; i < nRungs; i++)
  { rungs.push (new Cuboid (
      this.centre.x, this.centre.y, rungHt0 + i * spacing, wd2 - thick, thick, thick));
  }
  this.vertices = [];
  this.faces = [];
  for (var j = 0; j < rungs.length; j++)
  { var rj = rungs [j];
    for (i = 0; i < rj.vertices.length; i++) this.vertices.push (rj.vertices [i]);
    for (i = 0; i < rj.faces.length; i++) this.faces.push (rj.faces [i]);
  }
  for (i = 0; i < left.vertices.length; i++) this.vertices.push (left.vertices [i]);
  for (i = 0; i < left.faces.length; i++) this.faces.push (left.faces [i]);
  for (i = 0; i < right.vertices.length; i++) this.vertices.push (right.vertices [i]);
  for (i = 0; i < right.faces.length; i++) this.faces.push (right.faces [i]);
  for (i = 0; i < this.faces.length; i++) this.faces [i].setColour (rgb.r, rgb.g, rgb.b);
  this.halfheight = ht2;
  this.showAllFaces = true;
  this.background = false;
  this.freeFall = false;
  this.velocity = new Vector3D (0, 0, 0);
  this.angular = new Vector3D (0, 0, 0);
}

Ladder.prototype = Object.create (Shape.prototype);
Ladder.prototype.constructor = Ladder;
