// Copyright (c) Graham Relf, UK, 2020
// www.grelf.net
'use strict';

// colours are {r, g, b}
function Wheel (centrePoint3D, radius, axisVector3D, colour, rimColour, rimWidth)
{ Shape.call (this);
  this.centre = centrePoint3D;
  this.r = radius;
  this.axis = axisVector3D;
  this.colour = colour;
  this.rimColour = rimColour;
  this.rimWidth = rimWidth;
  this.halfheight = 0;
  this.movable = false;
  this.stroking = true; // rim
}

Wheel.prototype = Object.create (Shape.prototype);
Wheel.prototype.constructor = Wheel;


Wheel.prototype.view = function (me, fogNo)
{ this.minX = null; this.maxX = null; this.minY = null; this.maxY = null;
  var sxy0 = me.getScreenXYD (this.centre);
  var top = this.centre.newOffsetPt (0, 0, this.r);
  var sxyT = me.getScreenXYD (top);
  var axisBear = Math.atan2 (this.axis.dx, this.axis.dy);
  var left = this.centre.newOffsetPt (this.r * Math.cos (axisBear), this.r * Math.sin (axisBear), 0);
  var sxyL = me.getScreenXYD (left);
  var rotation = 0;
  var g2 = world.g2;
  g2.fillStyle = fog (this.colour.r, this.colour.g, this.colour.b, fogNo);
  g2.strokeStyle = fog (this.rimColour.r, this.rimColour.g, this.rimColour.b, fogNo);
//  g2.lineWidth = this.rimWidth;
  g2.beginPath ();
  g2.ellipse (sxy0.x, sxy0.y, Math.abs (sxyL.x - sxy0.x), Math.abs (sxyT.y - sxy0.y), rotation, 0, TWO_PI);
  g2.fill ();
  g2.stroke ();
  g2.lineWidth = 1;
};

Wheel.prototype.explode = function () {};
Wheel.prototype.rotateX = function (degs) {};
Wheel.prototype.rotateY = function (degs) {};
Wheel.prototype.rotateZ = function (degs) { this.axis.rotateZ (degs); };
