// Copyright (c) Graham Relf, UK, 2021
// www.grelf.net
'use strict';

// Form one shape from an array of shapes
function Composite (shapesArray)
{ Shape.call (this);
  var sumX = 0, sumY = 0, sumZ = 0, nFaces = 0;
  for (var i = 0; i < shapesArray.length; i++)
  { var shape = shapesArray [i];
    for (var iv = 0; iv < shape.vertices.length; iv++) this.vertices.push (shape.vertices [iv]);
    for (var ifc = 0; ifc < shape.faces.length; ifc++)
    { var face = shape.faces [ifc];
      face.parent = this;
      this.faces.push (face);
      this.fillColours.push (face.colour);
      sumX += face.centre.x; sumY += face.centre.y; sumZ += face.centre.z;
      nFaces++;
      face.iVerts = []; // used in Face.recentre()
      for (var ifv = 0; ifv < face.vertices.length; ifv++)
      { for (var isv = 0; isv < shape.vertices.length; isv++)
        { if (shape.vertices [isv] === face.vertices [ifv]) face.iVerts.push (isv);
  } } } }
  this.centre = new Point3D (sumX / nFaces, sumY / nFaces, sumZ / nFaces); // Mean of face centres
  this.radius = 0;
  for (i = 0; i < this.vertices.length; i++)
  { this.radius = Math.max (this.radius, this.vertices [i].distance (this.centre)); }
  this.showAllFaces = true;
}

Composite.prototype = Object.create (Shape.prototype);
Composite.prototype.constructor = Composite;
