// Copyright (c) Graham Relf, UK, 2020
// www.grelf.net
'use strict';

function Octahedron (xCentre, yCentre, zCentre, side)
{ Shape.call (this);
  this.centre = new Point3D (xCentre, yCentre, zCentre);
  this.fillColours = // default:
  [ {r:176, g:0, b:0}, // red
    {r:176, g:176, b:0}, // yellow
    {r:0, g:176, b:0}, // green
    {r:0, g:0, b:176},  // blue
    {r:0, g:176, b:0}, // green
    {r:0, g:0, b:176},  // blue
    {r:176, g:0, b:0}, // red
    {r:176, g:176, b:0} // yellow
  ];
  if (arguments.length > 4) this.fillColours = arguments [4];
  var s = side / (2 * Math.sqrt (2));
  this.vertices = new Array (6);
  this.vertices [0] = new Point3D (xCentre, yCentre, zCentre + s);//top
  this.vertices [1] = new Point3D (xCentre, yCentre + s, zCentre);
  this.vertices [2] = new Point3D (xCentre + s, yCentre, zCentre);
  this.vertices [3] = new Point3D (xCentre, yCentre - s, zCentre);
  this.vertices [4] = new Point3D (xCentre - s, yCentre, zCentre);
  this.vertices [5] = new Point3D (xCentre, yCentre, zCentre - s);//bottom
  this.faces = new Array (8);
  this.makeFace (0, [0, 1, 2]);
  this.makeFace (1, [0, 2, 3]);
  this.makeFace (2, [0, 3, 4]);
  this.makeFace (3, [0, 4, 1]);
  this.makeFace (4, [5, 1, 2]);
  this.makeFace (5, [5, 2, 3]);
  this.makeFace (6, [5, 3, 4]);
  this.makeFace (7, [5, 4, 1]);
  this.side = side;
  this.freeFall = false;
  this.velocity = new Vector3D (0, 0, 0);
  this.angular = new Vector3D (0, 0, 0);
}

Octahedron.prototype = Object.create (Shape.prototype);
Octahedron.prototype.constructor = Octahedron;
