// Copyright (c) Graham Relf, UK, 2020
// www.grelf.net
'use strict';

function Sprite (xCentre, yCentre, imageName) // Standing on ground (z = 0)
{ this.centre = new Point3D (xCentre, yCentre, 0);
  this.image = world.images [imageName];
  this.wd2 = this.image.width / 2;
  this.ht2 = this.image.height / 2;
  // For compatibility with all shapes:
  this.vertices = [];
  this.faces = [];
  this.background = false;
  this.movable = false;
  this.freeFall = false;
  this.velocity = new Vector3D (0, 0, 0);
  this.angular = new Vector3D (0, 0, 0);
  this.na = '() is not available for sprites';
}

Sprite.prototype.view = function (me, fogNo)
{ if (this.image.loaded)
  { var sxy = me.getScreenXYD (this.centre);
    var scale = 20 / sxy.d;
    world.drawImage (this.image, sxy.x - scale * this.wd2, sxy.y - scale * this.image.height,
      scale * this.image.width, scale * this.image.height, fogNo);
  }
};

Sprite.prototype.explode = function () { error ('explode' + this.na); };
Sprite.prototype.setAngular = function () { error ('setAngular' + this.na); };
Sprite.prototype.setColour = function () { error ('setColour' + this.na); };
Sprite.prototype.setStroke = function () { error ('setStroke' + this.na); };
Sprite.prototype.setStroking = function () { error ('setStroking' + this.na); };
Sprite.prototype.setSolid = function () { error ('setSolid' + this.na); };
Sprite.prototype.setFreeFall = function (bool) { this.freeFall = bool; };

Sprite.prototype.setVelocity = function (dx, dy, dz) 
{ this.velocity = new Vector3D (dx, dy, dz);
  this.movable = (dx !== 0 || dy !== 0 || dz !== 0);
};