// Copyright (c) Graham Relf, UK, 2020
// www.grelf.net
'use strict';

function Tetrahedron (xCentre, yCentre, zCentre, side)
{ Shape.call (this);
  this.centre = new Point3D (xCentre, yCentre, zCentre);
  this.fillColours = // default:
  [ {r:176, g:0, b:0}, // red
    {r:176, g:176, b:0}, // yellow
    {r:0, g:176, b:0}, // green
    {r:0, g:0, b:176}  // blue
  ];
  if (arguments.length > 4) this.fillColours = arguments [4];
  var s = side / (2 * Math.sqrt (2));
  this.vertices = new Array (4);
  this.vertices [0] = new Point3D (xCentre + s, yCentre + s, zCentre + s);
  this.vertices [1] = new Point3D (xCentre + s, yCentre - s, zCentre - s);
  this.vertices [2] = new Point3D (xCentre - s, yCentre + s, zCentre - s);
  this.vertices [3] = new Point3D (xCentre - s, yCentre - s, zCentre + s);
  this.faces = new Array (4);
  this.makeFace (0, [0, 1, 2]);
  this.makeFace (1, [1, 2, 3]);
  this.makeFace (2, [2, 3, 0]);
  this.makeFace (3, [3, 0, 1]);
  this.side = side;
  this.freeFall = false;
  this.velocity = new Vector3D (0, 0, 0);
  this.angular = new Vector3D (0, 0, 0);
}

Tetrahedron.prototype = Object.create (Shape.prototype);
Tetrahedron.prototype.constructor = Tetrahedron;
